function guessSuffix(terminalName) {
    if (typeof terminalName !== 'string') {
        return;
    }

    const items = terminalName.split('@');
    if (!items || (items.length < 2)) return;

    return `@${items[items.length - 1]}`;
}

function isPhoneNumber(terminalName) {
    if (typeof terminalName !== 'string') {
        return false;
    }

    if (terminalName.trim().length < 7) return false;

    return Boolean(terminalName.replace(/^\+/, '').match(/^\d+$/));
}

function indonesiaIntlNumberToZeroPrefix(phoneNumber) {
    if (!isPhoneNumber(phoneNumber)) {
        return phoneNumber;
    }

    return phoneNumber.replace(/^\+62/, '0');
}

exports.guessSuffix = guessSuffix;
exports.isPhoneNumber = isPhoneNumber;
exports.indonesiaIntlNumberToZeroPrefix = indonesiaIntlNumberToZeroPrefix;
